images=1:24;
% The kodim dataset should be placed in the folder data.
format compact;

% res contains the PSNR for all images.
% Row 1 corresponds to the results using sparse coding with a pre-trained dictionary
% Row 2 corresponds to the results using simultaneous sparse coding with a pre-trained dictionary
% Row 3 corresponds to the results using sparse coding with an adaptive dictionary (same as Row 1 + dictionary learning)
% Row 4 corresponds to the results using simultaneous sparse coding with an adaptive dictionary (same as Row 3 + dictionary learning)
res=zeros(4,length(images));
% load dictionary
load('dicts/dictrgb_n8.mat');

for ii=1:length(images);
   Io=double(imread(sprintf('./data/kodim%2.2d.png',ii)))/255;

   % creating the mosaicked image
   I=zeros(size(Io));
   I(1:2:end,2:2:end,1)=Io(1:2:end,2:2:end,1);
   I(1:2:end,1:2:end,2)=Io(1:2:end,1:2:end,2);
   I(2:2:end,2:2:end,2)=Io(2:2:end,2:2:end,2);
   I(2:2:end,1:2:end,3)=Io(2:2:end,1:2:end,3);

   % do not pay attention to the psnr values reported
   % during the optimization
   [IoutSC IoutSSC IoutLSC IoutLSSC]=demosaicking(I,D);

   % compute the PSNR while removing a 15-pixel boundary
   Iocrop=Io(16:end-15,16:end-15,:);
   Iout=IoutSC(16:end-15,16:end-15,:);
   res(1,ii)=psnr(Iocrop,Iout);
   Iout=IoutSSC(16:end-15,16:end-15,:);
   res(2,ii)=psnr(Iocrop,Iout);
   Iout=IoutLSC(16:end-15,16:end-15,:);
   res(3,ii)=psnr(Iocrop,Iout);
   Iout=IoutLSSC(16:end-15,16:end-15,:);
   res(4,ii)=psnr(Iocrop,Iout);
   res
   save('res.mat','res')
end
